<template>
  <base-dialog :show="!!error" title="Wystąpił błąd!" @close="handleError">
    {{ error }}
  </base-dialog>
  <div v-if="isLoading">
    <base-spinner></base-spinner>
  </div>
  <div v-else-if="!isLoading">
    <form @submit.prevent="submitForm" class="formStyling">
      <div class="form-control" :class="{ invalid: !username.isValid }">
        <label for="topic">Nazwa użytkownika</label>
        <input
          type="text"
          id="topic"
          v-model.trim="username.val"
          @blur="clearValidity('username')"
        />
        <p v-if="!username.isValid">Uzupełnij nazwę użytkownika.</p>
      </div>
      <div class="form-control" :class="{ invalid: !comment.isValid }">
        <label for="comment">Komentarz</label>
        <textarea
          id="comment"
          rows="2"
          v-model.trim="comment.val"
          @blur="clearValidity('comment')"
        ></textarea>
        <p v-if="!comment.isValid">Uzupełnij komentarz.</p>
      </div>
      <div class="button">
        <base-button>Dodaj komentarz</base-button>
      </div>
    </form>
  </div>
</template>

<script setup>
import { ref, defineProps } from "vue";
import { useStore } from "vuex";

const props = defineProps(["reportId"]);

const store = useStore();

const username = ref({
  val: "",
  isValid: true,
});
const comment = ref({
  val: "",
  isValid: true,
});

const formIsValid = ref(true);
const error = ref(null);
const isLoading = ref(false);

function handleError() {
  error.value = null;
}

function clearValidity(input) {
  this[input].isValid = true;
}

function validateForm() {
  formIsValid.value = true;
  if (username.value.val === "") {
    username.value.isValid = false;
    formIsValid.value = false;
  }
  if (comment.value.val === "") {
    comment.value.isValid = false;
    formIsValid.value = false;
  }
}

async function submitForm() {
  validateForm();

  if (!formIsValid.value) {
    return;
  }

  isLoading.value = true;
  try {
    await store.dispatch("addComment", {
      reportId: props.reportId,
      content: comment.value.val,
      user: username.value.val,
    });
    comment.value.val = "";
    username.value.val = "";
  } catch (er) {
    error.value = er.message || "Nie udało się dodać komentarza.";
  }
  isLoading.value = false;
}
</script>
